<?php
/******************************************************************************
* ThankYou.php                                                                *
*******************************************************************************
* For SMF: Simple Machines Forum                                              *
* Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                *
* =========================================================================== *
* Software Version:           SMF 1.1 RC2+                                    *
* Software by:                DIN1031                                         *
* Copyright 2005 by:     			DIN1031											                    *
* Support, News, Updates at:  http://mods.simplemachines.org                  *
*******************************************************************************
* This program is free software; you may redistribute it and/or modify it     *
* under the terms of the provided license as published by SMF.                *
*                                                                             *
* This program is distributed in the hope that it is and will be useful,      *
* but WITHOUT ANY WARRANTIES; without even any implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
******************************************************************************/
if (!defined('SMF'))
	die('Hacking attempt...');

/*
	This file exist only for handling the Thank You Mod :) i hope you enjoy it :x

	Function list:
		thank_you_post()
		- Creat a Thank You
		- Check if it realy a Thank You Thread
		- Check if the Thank you is Locked

		thank_you_add()
		- Change the Thread to a Thank you Thread

		thank_you_remove()
		- Delete the Thank You Thread

		thank_you_list()
		- Creat the Thank You list

		thank_you_lock()
		- Lock the Thank You Thread

		thank_you_loadColors()
		- Colorload (a faster way, because sometimes there could be 1000+ thank you users...

		thank_you_addfast($topicid = NULL)
		- 1.1 RC+ Add a thank you as topic Option
		- return false on nothing done

		thank_you_delete_id();
		- Delete a selected id from the list
		- session get must be set!
*/

function thank_you_post() {

	global $txt, $scripturl, $topic, $db_prefix, $modSettings, $board, $ID_MEMBER, $user_info;
	global $sc, $board_info, $context, $settings, $sourcedir;

	//Is this board a Thank you board?
	if(!$board_info['thank_you_topics_enable'])
		fatal_error($txt['d_no_thank_you_board'], false);

	//You must know only user who allowed to this schould use this function :P
	isAllowedTo('thank_you_post');

	//Load some Languagefiles :)
	loadLanguage('Errors');
	loadLanguage('ThankYou');

	//Check if topic has a Thank You (Return Error if Already set).
	$result = db_query("
		SELECT
			thank_you
		FROM {$db_prefix}topics
		WHERE ID_TOPIC = $topic
		LIMIT 1", __FILE__, __LINE__);

	$check = mysql_fetch_assoc($result);
	mysql_free_result($result);

	if(empty($check))
		fatal_error($txt['topic_gone'], false);
	if(isset($check['thank_you']) && $check['thank_you'] != 1)
		fatal_error($check['thank_you'] == 2 ? $txt['locked_thank_you_thread'] : $txt['no_thank_you_thread'], true);

	//Okay now check if you already postet your thank you :x
	$result = db_query("
		SELECT ID_MEMBER
		FROM {$db_prefix}thank_you
		WHERE ID_TOPIC = $topic AND ID_MEMBER = $ID_MEMBER
		LIMIT 1", __FILE__, __LINE__);

	$check = mysql_fetch_assoc($result);
	mysql_free_result($result);

	if(!empty($check))
		fatal_error($txt['one_thank_you_is_good'], false);
	else
		db_query("
			INSERT INTO {$db_prefix}thank_you
			(ID_TOPIC, ID_MEMBER, memberName, thank_you_time)
			VALUES ($topic, $ID_MEMBER, '$user_info[name]', ".time().")", __FILE__, __LINE__);

	redirectexit('topic=' . $topic . '.0');
}

function thank_you_add() {

	global $txt, $topic, $db_prefix, $ID_MEMBER, $board_info;

	//Is this board a Thank you board?
	if(!$board_info['thank_you_topics_enable'])
		fatal_error($txt['d_no_thank_you_board'], false);

	//Check First the Premission :)
	if (!allowedTo('thank_you_add_own') && !allowedTo('thank_you_add_any'))
		fatal_lang_error(1, false);

	//Load some Languagefiles :)
	loadLanguage('Errors');
	loadLanguage('ThankYou');

	//OK Topic set?
	if(empty($topic))
		fatal_error($txt['topic_gone'], false);

	//Check if topic has a Thank You (Return Error if Already set).
	$result = db_query("
		SELECT
			ID_TOPIC, ID_MEMBER_STARTED, thank_you
		FROM {$db_prefix}topics
		WHERE ID_TOPIC = $topic
		LIMIT 1", __FILE__, __LINE__);

	$check = mysql_fetch_assoc($result);
	mysql_free_result($result);

	//First Check the rights :)
	if(!allowedTo('thank_you_add_any') && $ID_MEMBER != $check['ID_MEMBER_STARTED'])
		fatal_lang_error(1, false);

	if(empty($check))
		fatal_error($txt['topic_gone'], false);
	elseif($check['thank_you'] == 1 || $check['thank_you'] == 2)
		//Tsts some people try it... <<
		fatal_error($txt['thank_you_already_set'], false);
	else
		//Update it
		db_query("
		UPDATE {$db_prefix}topics
		SET thank_you = 1
		WHERE ID_TOPIC = $topic
		LIMIT 1", __FILE__, __LINE__);

	//Okay all done now Reddirect exit :)
	redirectexit('topic=' . $topic . '.0');
}

function thank_you_remove() {

	global $txt, $topic, $db_prefix, $ID_MEMBER, $board_info;

	//Is this board a Thank you board?
	if(!$board_info['thank_you_topics_enable'])
		fatal_error($txt['d_no_thank_you_board'], false);

	//Check First the Premission :)
	if (!allowedTo('thank_you_remove_own') && !allowedTo('thank_you_remove_any'))
		fatal_lang_error(1, false);

	//Load some Languagefiles :)
	loadLanguage('Errors');
	loadLanguage('ThankYou');

	//OK Topic set?
	if(empty($topic))
		fatal_error($txt['topic_gone'], false);

	//Check if topic has a Thank You (Return Error if not set).
	$result = db_query("
		SELECT
			ID_TOPIC, ID_MEMBER_STARTED, thank_you
		FROM {$db_prefix}topics
		WHERE ID_TOPIC = $topic
		LIMIT 1", __FILE__, __LINE__);

	$check = mysql_fetch_assoc($result);
	mysql_free_result($result);

	//First Check the rights :)
	if(!allowedTo('thank_you_remove_any') && $ID_MEMBER != $check['ID_MEMBER_STARTED'])
		fatal_lang_error(1, false);

	if(empty($check))
		fatal_error($txt['topic_gone'], false);
	elseif($check['thank_you'] != 1 && $check['thank_you'] != 2)
		//Tsts some people try it... <<
		fatal_error($txt['thank_you_not_set'], true);
	else {
		//Remove all and set the topic to 0 :)
		db_query("
		UPDATE {$db_prefix}topics
		SET thank_you = 0
		WHERE ID_TOPIC = $topic
		LIMIT 1", __FILE__, __LINE__);

		db_query("
		DELETE FROM {$db_prefix}thank_you
		WHERE ID_TOPIC = $topic", __FILE__, __LINE__);

	}
	//Okay all done now Reddirect exit :)
	redirectexit('topic=' . $topic . '.0');
}

//Stand alone Function :), at least for a Load without userlist :)

function thank_you_loadPremission() {
	global $txt, $scripturl, $topic, $db_prefix, $modSettings, $board, $ID_MEMBER, $user_info;
	global $sc, $board_info, $context, $settings, $sourcedir, $user_profile;

	//You can do nothing :)
	$context['thank_you']['premission'] = array(
		'view' => allowedTo('thank_you_view'),
		'add' => false,
		'post' => false,
		'lock' => false,
		'delete' => false,
	);

	//This is for 1.1RC1
	$context['thank_you_delete'] = false;
	$context['thank_you_lock'] = false;

	//Is this board a Thank you board? {
	if(!$board_info['thank_you_topics_enable']) {
		//Oh this is not allowed when not enable this ;P
		$context['thank_you']['premission']['view'] = false;
		return;
	}
	//Oh your not allowed to do anything :P
	if(!allowedTo('thank_you_view'))
		return;

	//Topic has a thank you?
	$result = db_query("
		SELECT
			ID_TOPIC, ID_MEMBER_STARTED, thank_you, ID_FIRST_MSG
		FROM {$db_prefix}topics
		WHERE ID_TOPIC = $topic
		LIMIT 1", __FILE__, __LINE__);

	$check = mysql_fetch_assoc($result);
	mysql_free_result($result);

	//I need it later :P (and want save a little bit the resources).
	$context['thank_you']['TopicSubject'] = &$check['ID_FIRST_MSG'];

	//Nothing?
	if(empty($check))
		return;
	//No Thank You? Only Add allowed :)
	elseif($check['thank_you'] != 1 && $check['thank_you'] != 2) {
		$context['thank_you']['premission']['add'] = allowedTo('thank_you_add_any') || (allowedTo('thank_you_add_own') && $ID_MEMBER == $check['ID_MEMBER_STARTED']);
		return;
	}
	//Oh Thank You is set
	elseif($check['thank_you'] == 1 || $check['thank_you'] == 2) {
		$context['thank_you']['premission']['lock'] = allowedTo('thank_you_lock_any') || (allowedTo('thank_you_lock_own') && $ID_MEMBER == $check['ID_MEMBER_STARTED']);
		$context['thank_you']['premission']['delete'] = allowedTo('thank_you_remove_any') || (allowedTo('thank_you_remove_own') && $ID_MEMBER == $check['ID_MEMBER_STARTED']);

		//This is for 1.1RC1
		$context['thank_you_lock'] = $context['thank_you']['premission']['lock'];
		$context['thank_you_delete'] = $context['thank_you']['premission']['delete'];

		$result = db_query("
			SELECT ID_MEMBER
			FROM {$db_prefix}thank_you
			WHERE ID_TOPIC = $topic AND ID_MEMBER = $ID_MEMBER
			LIMIT 1", __FILE__, __LINE__);

		$post = mysql_fetch_assoc($result);
		mysql_free_result($result);

		//You can only post if you not already posted and the thx is not closed :)
		$context['thank_you']['premission']['post'] = allowedTo('thank_you_post') && ($check['thank_you'] == 1 && empty($post) && $check['ID_MEMBER_STARTED'] != $ID_MEMBER);

		//For My Hide Mod... know you can see the hidden text
		if(!empty($post) || $ID_MEMBER == $check['ID_MEMBER_STARTED']) {
			if (!empty($modSettings['Thank_You_ShowHidden']))
				$context['user_post_avaible'] = 1;
			if (!empty($modSettings['Thank_You_ShowHidePostReply']))
				$context['user_post_avaible_leafv'] = 1;
		}

		return;
	}
	//error... at least return :)
	else
		return;
}
//This Functions is used for the listing and for normal load in Display php :x

function thank_you_list($load_template = true) {

	global $txt, $scripturl, $topic, $db_prefix, $modSettings, $board, $ID_MEMBER, $user_info;
	global $sc, $board_info, $context, $settings, $sourcedir, $color_profile;

	$context['thank_you']['HowMany'] = 0;
	$context['thank_you']['info'] = '';
	$context['thank_you']['link'] = '';
	$context['thank_you']['MemberList'] = '';
	$context['thank_you']['TopicSubject'] = '';
	$context['thank_you']['TopicLink'] = '';
	$context['thank_you']['list'] = array();

	//At least he can do nothing
	//Load the Premissions
	thank_you_loadPremission();

	//Load some Languagefiles :)
	loadLanguage('Errors');
	loadLanguage('ThankYou');
	if($load_template) {
		$context['page_title'] = $txt['thank_you_list'];
		if(!empty($context['thank_you']['TopicSubject'])) {

			$idmsg_thx = $context['thank_you']['TopicSubject'];

			//I Need this subjet so i load it :)
			$result = db_query("
				SELECT subject
				FROM {$db_prefix}messages
				WHERE ID_MSG = $idmsg_thx
				LIMIT 1", __FILE__, __LINE__);

			$subject = mysql_fetch_assoc($result);
			mysql_free_result($result);

			$context['thank_you']['TopicSubject'] = $subject['subject'];
		}
		loadTemplate('ThankYou');
	}

	//OK Topic set?
	if(empty($topic))
		fatal_error($txt['topic_gone'], false);

	$context['thank_you']['TopicLink'] = '<a href="' . $scripturl . '?topic='.$topic.'.0">'.$txt[250].'</a>';

	if(!allowedTo('thank_you_view')) {
		if(!$load_template)
			return false;
		else
			fatal_error($txt['no_users_in_list'], false);
	}

	//I creat only a list if it allowed :)
	$result = db_query("
		SELECT COUNT(*)
		FROM {$db_prefix}thank_you
		WHERE ID_TOPIC = $topic
		GROUP BY ID_TOPIC", __FILE__, __LINE__);

	//How many Posts are made :)
	$check = mysql_fetch_assoc($result);
	mysql_free_result($result);

	if(!empty($check))
		$context['thank_you']['HowMany'] = $check['COUNT(*)'];

	if(empty($context['thank_you']['HowMany'])) {
			$context['thank_you']['info'] = $txt['no_users_in_list'];
			$context['thank_you']['link'] = $txt['no_users_in_list'];
			return true;
	}

	//Okay return only the information for the link :x
	if(!empty($modSettings['Thank_You_LinkListOnly']) && !isset($_REQUEST['complete'])) {
		$context['thank_you']['info'] = '<a href="' . $scripturl . '?action=thankyoulist;complete;topic='.$topic.'.0">'.$txt['thank_you_link1'].($context['thank_you']['HowMany'] == 1 ? $txt['thank_you_link2a'] : $txt['thank_you_link2b']).$txt['thank_you_link3'].$context['thank_you']['HowMany'].($context['thank_you']['HowMany'] == 1 ? $txt['thank_you_link4a'] : $txt['thank_you_link4b']).'</a>';
		return (!$load_template ? true : '');
	}

	//Build a correct Limit :)
	$limit = 'LIMIT '.(!empty($modSettings['Thank_You_UserPreview']) && $modSettings['Thank_You_UserPreview'] < $context['thank_you']['HowMany'] && !isset($_REQUEST['complete']) ? $modSettings['Thank_You_UserPreview'] : $context['thank_you']['HowMany']);

	//Load the List (Or the preview list)
	//I create only a list if it allowed :)
	$result = db_query("
		SELECT ID_THX, ID_MEMBER, memberName, thank_you_time
		FROM {$db_prefix}thank_you
		WHERE ID_TOPIC = $topic
		ORDER BY ID_THX".(empty($modSettings['Thank_You_UserOrder']) ? " ASC" : " DESC")."
		$limit", __FILE__, __LINE__);

	$id_collect = array();
	$id_list = array();
	$id_time = array();

	while ($row = mysql_fetch_assoc($result)) {
		//This list is for deletet Members... and not deleted Thank yous... (I need some information for this users :x).
		$id_list[$row['ID_MEMBER']] = array (
			'id' => $row['ID_MEMBER'],
			'name' => $row['memberName'],
		);
		//This to load the MemberData... hope not to much XD.
		$id_collect[$row['ID_THX']] = $row['ID_MEMBER'];
		$id_time[$row['ID_THX']] = $row['thank_you_time'];
	}
	mysql_free_result($result);

	if(empty($id_collect)) {
		if(!$load_template) {
			$context['thank_you']['info'] = $txt['no_users_in_list'];
			$context['thank_you']['link'] = $txt['no_users_in_list'];
			return true;
		}
		else
			fatal_error($txt['no_users_in_list'], false);
	}

	//Build the link for the list each time :)
	$context['thank_you']['link'] = '<a href="' . $scripturl . '?action=thankyoulist;complete;topic='.$topic.'.0">'.$txt['thank_you_link1'].($context['thank_you']['HowMany'] == 1 ? $txt['thank_you_link2a'] : $txt['thank_you_link2b']).$txt['thank_you_link3'].$context['thank_you']['HowMany'].($context['thank_you']['HowMany'] == 1 ? $txt['thank_you_link4a'] : $txt['thank_you_link4b']).'.</a><br />';

	//Know Load the MemberData...
	thank_you_loadColors($id_collect);

	//Now build the Context :)
	if(!empty($modSettings['Thank_You_UserPreview']) && $modSettings['Thank_You_UserPreview'] < $context['thank_you']['HowMany'] && !isset($_REQUEST['complete']))
		$context['thank_you']['info'] = $context['thank_you']['link'];
	else
		$context['thank_you']['info'] =  $txt['thank_you_link5'];

	if(!empty($modSettings['Thank_You_AddCounter'])) {
		if(empty($modSettings['Thank_You_UserOrder']))
			$thx_counter = 1;
		else
			$thx_counter = $context['thank_you']['HowMany'];
		$thx_counttext = '';
	}
	else
		$thx_counttext = '';

	foreach($id_collect as $id_thx => $id) {
		//Build this only if allowed to it and yes if you think it's a good idea xD
		$delete_mem_link = allowedTo('thank_you_remove_mem_any') || (allowedTo('thank_you_remove_mem_own') && $ID_MEMBER == $id) ? ' <a href="'.$scripturl.'?action=thankyouremovedm;thxid='.$id_thx.';topic='.$topic.';sesc='.$context['session_id'].'" onclick="return confirm(\''.$txt['d_remove_thank_you_mem'].'?\');"><span style="color:red;">*</span></a>' : '';
		
		//Older Thank You Posts have no time ;)		
		if(!empty($id_time[$id_thx]))
			$thank_you_time = timeformat($id_time[$id_thx], false);
		else
			$thank_you_time = $txt[470];

		if(!empty($modSettings['Thank_You_AddCounter'])) {
			$thx_counttext = $thx_counter.'. ';
			if(empty($modSettings['Thank_You_UserOrder']))
				$thx_counter++;
			else
				$thx_counter--;
		}

		//Make a simple list... sorry that i add it in Version 1.2.0.
		$context['thank_you']['list'][$id_thx] = array(
			'ID_THX' => $id_thx,
			'counter' => $thx_counttext,
			'name' => $id_list[$id]['name'],
			'ID_MEMBER' => $id,
			'link' => $thx_counttext.$id_list[$id]['name'].$delete_mem_link,
			'time' => $thank_you_time,
		);
		
		//Add colors to the link or not
		if(!isset($color_profile[$id]))
			$context['thank_you']['info'] .= $thx_counttext.$id_list[$id]['name'].$delete_mem_link.', ';
		else {
			$link = '';
			$profile = $color_profile[$id];
			if(!empty($modSettings['Thank_You_MemberColor']))
				$link = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $thank_you_time . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $thx_counttext . $profile['realName'] . '</span></a>'.$delete_mem_link.', ';
			else
				$link = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $thank_you_time . '">' . $thx_counttext . $profile['realName'] . '</a>'.$delete_mem_link.', ';
		
			//Replace the link with the correct one :)
			$context['thank_you']['info'] .= $link;
			$context['thank_you']['list'][$id_thx]['link'] = substr($link, 0, -2);
			$context['thank_you']['list'][$id_thx]['ID_MEMBER'] = $profile['ID_MEMBER'];
			$context['thank_you']['list'][$id_thx]['name'] = $profile['realName'];
		}
	}

	//Remove some of the last two letters :P
	$context['thank_you']['info'] = substr($context['thank_you']['info'], 0, -2);

	//Add the link at the end of the text :X
	if(!empty($modSettings['Thank_You_AddLink']) && (empty($modSettings['Thank_You_UserPreview']) || $modSettings['Thank_You_UserPreview'] >= $context['thank_you']['HowMany']) && !isset($_REQUEST['complete']))
		$context['thank_you']['info'] .= '<br /><br />'.$context['thank_you']['link'];

	if(!empty($modSettings['Thank_You_UserPreview']) && $modSettings['Thank_You_UserPreview'] < $context['thank_you']['HowMany'] && !isset($_REQUEST['complete']))
		$context['thank_you']['info'] .= ', <a href="' . $scripturl . '?action=thankyoulist;complete;topic='.$topic.'.0">...</a>';

	if(!$load_template)
		return true;
}

function thank_you_lock() {

	global $txt, $topic, $db_prefix, $ID_MEMBER, $board_info;

	//Is this board a Thank you board?
	if(!$board_info['thank_you_topics_enable'])
		fatal_error($txt['d_no_thank_you_board'], false);

	//Check First the Premission :)
	if (!allowedTo('thank_you_lock_own') && !allowedTo('thank_you_lock_any'))
		fatal_lang_error(1, false);

	//Load some Languagefiles :)
	loadLanguage('Errors');
	loadLanguage('ThankYou');

	//OK Topic set?
	if(empty($topic))
		fatal_error($txt['topic_gone'], false);

	//Check if topic has a Thank You (Return Error if Already set).
	$result = db_query("
		SELECT
			ID_TOPIC, ID_MEMBER_STARTED, thank_you
		FROM {$db_prefix}topics
		WHERE ID_TOPIC = $topic
		LIMIT 1", __FILE__, __LINE__);

	$check = mysql_fetch_assoc($result);
	mysql_free_result($result);

	//First Check the rights :)
	if(!allowedTo('thank_you_lock_any') && $ID_MEMBER != $check['ID_MEMBER_STARTED'])
		fatal_lang_error(1, false);

	if(empty($check))
		fatal_error($txt['topic_gone'], false);
	elseif($check['thank_you'] != 1 && $check['thank_you'] != 2)
		//Tsts some people try it... <<
		fatal_error($txt['no_thank_you_thread'], false);
	else
		//Update it
		db_query("
		UPDATE {$db_prefix}topics
		SET thank_you = ".($check['thank_you'] == 1 ? "2" : "1") ."
		WHERE ID_TOPIC = $topic
		LIMIT 1", __FILE__, __LINE__);

	//Okay all done now Reddirect exit :)
	redirectexit('topic=' . $topic . '.0');

}

//This is  a small Skript to load colors for Thank You(a little bit faster... because sometime i need 100+ colors :x)
function thank_you_loadColors($users) {
	global $color_profile, $db_prefix, $modSettings;

	// Can't just look for no users :P.
	if (empty($users))
		return false;

	// Make sure it's an array.
	$users = !is_array($users) ? array($users) : array_unique($users);

	if (empty($users))
		return false;

	// Load the data.
	$request = db_query("
		SELECT
		mem.ID_MEMBER AS ID_MEMBER, mem.realName AS realName,
		mg.onlineColor AS member_group_color, IFNULL(mg.groupName, '') AS member_group,
		pg.onlineColor AS post_group_color, IFNULL(pg.groupName, '') AS post_group
		FROM {$db_prefix}members AS mem
		LEFT JOIN {$db_prefix}membergroups AS pg ON (pg.ID_GROUP = mem.ID_POST_GROUP)
		LEFT JOIN {$db_prefix}membergroups AS mg ON (mg.ID_GROUP = mem.ID_GROUP)
		WHERE mem.ID_MEMBER ".(count($users) == 1 ? " = '" . current($users) . "'" : " IN ('" . implode("', '", $users) . "')"), __FILE__, __LINE__);

	$loaded_ids = array();
	while ($row = mysql_fetch_assoc($request))
	{
		$loaded_ids[] = $row['ID_MEMBER'];
		$color_profile[$row['ID_MEMBER']] = $row;
	}
	mysql_free_result($request);

	return empty($loaded_ids) ? false : $loaded_ids;
}

function thank_you_addfast($topicid = null) {

	global $db_prefix, $ID_MEMBER;

	//OK Topic set?
	if(empty($topicid))
		return false;

	//Check if topic has a Thank You (Return Error if Already set).
	$result = db_query("
		SELECT
			ID_TOPIC, ID_MEMBER_STARTED, thank_you
		FROM {$db_prefix}topics
		WHERE ID_TOPIC = $topicid
		LIMIT 1", __FILE__, __LINE__);

	$check = mysql_fetch_assoc($result);
	mysql_free_result($result);

	//The rights are importend!
	if(!allowedTo('thank_you_add_any') && $ID_MEMBER != $check['ID_MEMBER_STARTED'])
		return false;
	elseif(empty($check) || $check['thank_you'] == 1 || $check['thank_you'] == 2)
		return false;
	else
		//Update it
		db_query("
		UPDATE {$db_prefix}topics
		SET thank_you = 1
		WHERE ID_TOPIC = $topicid
		LIMIT 1", __FILE__, __LINE__);

	return true;
}

//Delte user from the list...
function thank_you_delete_id() {

	global $txt, $topic, $db_prefix, $ID_MEMBER, $board_info;


	//Load some Languagefiles :)
	loadLanguage('Errors');

	//Check teh Session
	checkSession('get');

	//Is this board a Thank you board?
	if(!$board_info['thank_you_topics_enable'])
		fatal_error($txt['d_no_thank_you_board'], false);

	if(empty($_GET['thxid']) || !is_numeric($_GET['thxid']) || $_GET['thxid'] < 1)
		fatal_error($txt['d_remove_thank_no_id'], false);
	else
		$_GET['thxid'] = (int) $_GET['thxid'];

	//OK Topic set?
	if(empty($topic))
		fatal_error($txt['topic_gone'], false);

	//Check First the Premission :)
	if (!allowedTo('thank_you_remove_mem_any') && !allowedTo('thank_you_remove_mem_own'))
		fatal_lang_error(1, false);

	//Okay allowed to delete any? if not than i must check first something :)
	if(!allowedTo('thank_you_remove_mem_any')) {
		//Check if topic has a Thank You (Return Error if Already set).
		$result = db_query("
			SELECT
				ID_TOPIC, ID_MEMBER
			FROM {$db_prefix}thank_you
			WHERE ID_THX = ".$_GET['thxid']."
				AND ID_TOPIC = $topic
			LIMIT 1", __FILE__, __LINE__);

		$check = mysql_fetch_assoc($result);
		mysql_free_result($result);

		//Allowed?
		if($check['ID_MEMBER'] != $ID_MEMBER)
			fatal_lang_error(1, false);
	}

	//Delete it...
	db_query("
	DELETE FROM {$db_prefix}thank_you
	WHERE ID_THX = ".$_GET['thxid']."
		AND ID_TOPIC = $topic
	LIMIT 1", __FILE__, __LINE__);

	//Okay all done now Reddirect exit :)
	redirectexit('topic=' . $topic . '.0');
}
?>